package eu.mhsl.minecraft.pixelblocks.pixelblock;

import eu.mhsl.minecraft.pixelblocks.utils.MinMaxUtil;
import org.bukkit.Location;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Interaction;

import java.util.List;

public class PixelBlockHitbox {
    private final Interaction hitbox;

    public PixelBlockHitbox(boolean fullBlock, Location pixelBlockLocation, float hitboxOffset, List<Pixel> pixels, int pixelsPerBlock) {
        if(fullBlock || true) {
            hitbox = (Interaction) pixelBlockLocation.getWorld().spawnEntity(
                pixelBlockLocation.clone().add(0.5, -hitboxOffset, 0.5),
                EntityType.INTERACTION
            );
            hitbox.setInteractionHeight(1 + 2*hitboxOffset);
            hitbox.setInteractionWidth(1 + 2*hitboxOffset);
        } else {
            double startingX = MinMaxUtil.getMinProperty(pixels, pixel -> pixel.location.getX());
            double startingY = MinMaxUtil.getMinProperty(pixels, pixel -> pixel.location.getY());
            double startingZ = MinMaxUtil.getMinProperty(pixels, pixel -> pixel.location.getZ());

            double endingX = MinMaxUtil.getMaxProperty(pixels, pixel -> pixel.location.getX());
            double endingY = MinMaxUtil.getMaxProperty(pixels, pixel -> pixel.location.getY());
            double endingZ = MinMaxUtil.getMaxProperty(pixels, pixel -> pixel.location.getZ());

            Location spawnLocation = pixelBlockLocation.clone().add(
                ((startingX+endingX+1)/2)/pixelsPerBlock,
                (startingY/pixelsPerBlock)-hitboxOffset,
                ((startingZ+endingZ+1)/2)/pixelsPerBlock
            );

            float height = (float) (endingY-startingY+1)/pixelsPerBlock + 2*hitboxOffset;

            float width;
            if((endingX-startingX) > (endingZ-startingZ)) {
                width = (float) (endingX-startingX+1)/pixelsPerBlock + 2*hitboxOffset;
            } else {
                width = (float) (endingZ-startingZ+1)/pixelsPerBlock + 2*hitboxOffset;
            }

            if(spawnLocation.getX()+width/2 > pixelBlockLocation.getX()+1) {
                spawnLocation.subtract((spawnLocation.getX()+width/2)-(pixelBlockLocation.getX()+1), 0, 0);
            }
            if(spawnLocation.getX()-width/2 < pixelBlockLocation.getX()) {
                spawnLocation.add(pixelBlockLocation.getX()-(spawnLocation.getX()-width/2), 0, 0);
            }

            if(spawnLocation.getZ()+width/2 > pixelBlockLocation.getZ()+1) {
                spawnLocation.subtract(0, 0, (spawnLocation.getZ()+width/2)-(pixelBlockLocation.getZ()+1));
            }
            if(spawnLocation.getZ()-width/2 < pixelBlockLocation.getZ()) {
                spawnLocation.add(0, 0, pixelBlockLocation.getZ()-(spawnLocation.getZ()-width/2));
            }

            hitbox = (Interaction) pixelBlockLocation.getWorld().spawnEntity(
                spawnLocation,
                EntityType.INTERACTION
            );

            hitbox.setInteractionHeight(height);
            hitbox.setInteractionWidth(width);
        }
    }

    public void remove() {
        this.hitbox.remove();
    }
}
